import { logger, chalk, isApiOnly } from '@modern-js/utils';
import server from '@modern-js/prod-server';
import { printInstructions } from "../utils/printInstructions";
export const start = async api => {
  var _userConfig$source;

  const appContext = api.useAppContext();
  const userConfig = api.useResolvedConfigContext();
  const hookRunners = api.useHookRunners();
  const {
    appDirectory,
    port,
    serverConfigFile
  } = appContext;
  logger.log(chalk.cyan(`Starting the modern server...`));
  const apiOnly = await isApiOnly(appContext.appDirectory, userConfig === null || userConfig === void 0 ? void 0 : (_userConfig$source = userConfig.source) === null || _userConfig$source === void 0 ? void 0 : _userConfig$source.entriesDir);
  const app = await server({
    pwd: appDirectory,
    config: userConfig,
    plugins: appContext.plugins.filter(p => p.server).map(p => p.server),
    serverConfigFile,
    apiOnly
  });
  app.listen(port, async err => {
    if (err) {
      throw err;
    }

    await printInstructions(hookRunners, appContext, userConfig);
  });
};