"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.start = void 0;

var _utils = require("@modern-js/utils");

var _prodServer = _interopRequireDefault(require("@modern-js/prod-server"));

var _printInstructions = require("../utils/printInstructions");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const start = async api => {
  var _userConfig$source;

  const appContext = api.useAppContext();
  const userConfig = api.useResolvedConfigContext();
  const hookRunners = api.useHookRunners();
  const {
    appDirectory,
    port,
    serverConfigFile
  } = appContext;

  _utils.logger.log(_utils.chalk.cyan(`Starting the modern server...`));

  const apiOnly = await (0, _utils.isApiOnly)(appContext.appDirectory, userConfig === null || userConfig === void 0 ? void 0 : (_userConfig$source = userConfig.source) === null || _userConfig$source === void 0 ? void 0 : _userConfig$source.entriesDir);
  const app = await (0, _prodServer.default)({
    pwd: appDirectory,
    config: userConfig,
    plugins: appContext.plugins.filter(p => p.server).map(p => p.server),
    serverConfigFile,
    apiOnly
  });
  app.listen(port, async err => {
    if (err) {
      throw err;
    }

    await (0, _printInstructions.printInstructions)(hookRunners, appContext, userConfig);
  });
};

exports.start = start;