"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
Object.defineProperty(exports, "defineConfig", {
  enumerable: true,
  get: function () {
    return _core.defineConfig;
  }
});

var _path = _interopRequireDefault(require("path"));

var _core = require("@modern-js/core");

var _pluginJarvis = _interopRequireDefault(require("@modern-js/plugin-jarvis"));

var _utils = require("@modern-js/utils");

var _analyze = _interopRequireDefault(require("./analyze"));

var _hooks = require("./hooks");

var _locale = require("./locale");

var _language = require("./utils/language");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

const upgradeModel = _utils.Import.lazy('@modern-js/upgrade', require);

var _default = () => ({
  name: '@modern-js/app-tools',
  post: ['@modern-js/plugin-analyze', '@modern-js/plugin-ssr', '@modern-js/plugin-state', '@modern-js/plugin-router', '@modern-js/plugin-polyfill'],
  registerHook: _hooks.hooks,
  usePlugins: [(0, _analyze.default)(), (0, _pluginJarvis.default)()],
  setup: api => {
    const locale = (0, _language.getLocaleLanguage)();

    _locale.i18n.changeLanguage({
      locale
    });

    return {
      commands({
        program
      }) {
        program.command('dev').usage('[options]').description(_locale.i18n.t(_locale.localeKeys.command.dev.describe)).option('-c --config <config>', _locale.i18n.t(_locale.localeKeys.command.shared.config)).option('-e --entry [entry...]', _locale.i18n.t(_locale.localeKeys.command.dev.entry)).option('--analyze', _locale.i18n.t(_locale.localeKeys.command.shared.analyze)).option('--api-only', _locale.i18n.t(_locale.localeKeys.command.dev.apiOnly)).action(async options => {
          const {
            dev
          } = await Promise.resolve().then(() => _interopRequireWildcard(require("./commands/dev")));
          await dev(api, options);
        });
        program.command('build').usage('[options]').description(_locale.i18n.t(_locale.localeKeys.command.build.describe)).option('-c --config <config>', _locale.i18n.t(_locale.localeKeys.command.shared.config)).option('--analyze', _locale.i18n.t(_locale.localeKeys.command.shared.analyze)).action(async options => {
          const {
            build
          } = await Promise.resolve().then(() => _interopRequireWildcard(require("./commands/build")));
          await build(api, options);
        });
        program.command('start').usage('[options]').description(_locale.i18n.t(_locale.localeKeys.command.start.describe)).option('--api-only', _locale.i18n.t(_locale.localeKeys.command.dev.apiOnly)).option('-c --config <config>', _locale.i18n.t(_locale.localeKeys.command.shared.config)).action(async () => {
          const {
            start
          } = await Promise.resolve().then(() => _interopRequireWildcard(require("./commands/start")));
          await start(api);
        });
        program.command('deploy').usage('[options]').option('-c --config <config>', _locale.i18n.t(_locale.localeKeys.command.shared.config)).description(_locale.i18n.t(_locale.localeKeys.command.deploy.describe)).action(async options => {
          const {
            build
          } = await Promise.resolve().then(() => _interopRequireWildcard(require("./commands/build")));
          await build(api);
          const {
            deploy
          } = await Promise.resolve().then(() => _interopRequireWildcard(require("./commands/deploy")));
          await deploy(api, options); // eslint-disable-next-line no-process-exit

          process.exit(0);
        });
        program.command('new').usage('[options]').description(_locale.i18n.t(_locale.localeKeys.command.new.describe)).option('-d, --debug', _locale.i18n.t(_locale.localeKeys.command.new.debug), false).option('-c, --config <config>', _locale.i18n.t(_locale.localeKeys.command.new.config)).option('--dist-tag <tag>', _locale.i18n.t(_locale.localeKeys.command.new.distTag)).option('--registry', _locale.i18n.t(_locale.localeKeys.command.new.registry)).action(async options => {
          const {
            MWANewAction
          } = await Promise.resolve().then(() => _interopRequireWildcard(require('@modern-js/new-action')));
          await MWANewAction(_objectSpread(_objectSpread({}, options), {}, {
            locale
          }));
        });
        program.command('inspect').description('inspect internal webpack config').option(`--env <env>`, _locale.i18n.t(_locale.localeKeys.command.inspect.env), 'development').option('--output <output>', _locale.i18n.t(_locale.localeKeys.command.inspect.output), '/').option('--no-console', _locale.i18n.t(_locale.localeKeys.command.inspect.noConsole)).option('--verbose', _locale.i18n.t(_locale.localeKeys.command.inspect.verbose)).option('-c --config <config>', _locale.i18n.t(_locale.localeKeys.command.shared.config)).action(async options => {
          const {
            inspect
          } = await Promise.resolve().then(() => _interopRequireWildcard(require("./commands/inspect")));
          inspect(api, options);
        });
        upgradeModel.defineCommand(program.command('upgrade'));
      },

      // 这里会被 core/initWatcher 监听的文件变动触发，如果是 src 目录下的文件变动，则不做 restart
      async fileChange(e) {
        const {
          filename,
          eventType
        } = e;
        const appContext = api.useAppContext();
        const {
          appDirectory,
          srcDirectory
        } = appContext;

        const absolutePath = _path.default.resolve(appDirectory, filename);

        if (!absolutePath.includes(srcDirectory) && (eventType === 'change' || eventType === 'unlink')) {
          const {
            closeServer
          } = await Promise.resolve().then(() => _interopRequireWildcard(require("./utils/createServer")));
          await closeServer();
          await _core.cli.restart();
        }
      },

      async beforeRestart() {
        (0, _utils.cleanRequireCache)([require.resolve("./analyze")]);
      }

    };
  }
});

exports.default = _default;