"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getServer = exports.createServer = exports.closeServer = void 0;

var _server = require("@modern-js/server");

let server = null;

const getServer = () => server;

exports.getServer = getServer;

const closeServer = async () => {
  if (server) {
    await server.close();
    server = null;
  }
};

exports.closeServer = closeServer;

const createServer = async options => {
  if (server) {
    await server.close();
  }

  server = new _server.Server(options);
  const app = await server.init();
  return app;
};

exports.createServer = createServer;